/* --------- LabWindows Generated Code:   Thu Mar 09 11:22:41 1995 --------- */

#include "C:\LW\INCLUDE\lwsystem.h"
#include "C:\LW\INCLUDE\gpib.h"
#include "C:\LW\INCLUDE\formatio.h"

/*                        ͸                  */
/*                                                */
/*        ͻ   ͻ        ͻ ͸            Ŀ   Ŀ */
/*                             ͼ ͻ                  */
/* ; ; ͼ        ; ͼ  ;          */
/* LabTest 2.0 instrument file */
/* Rohde & Schwarz Signal Generator SMG */
/* July 1991 */

#include "rssmg.h"

/* * */
void smg_set_rf (dev, rf, rfunit)
int dev;
double rf;
int rfunit;
{
    int dy;
    
    switch (rfunit)  {
    case 0:
        dy = Fmt (smg_cmd, "RF %fHZ", rf);
        break;
    case 1:
        dy = Fmt (smg_cmd, "RF %fKHZ", rf);
        break;
    case 2:
        dy = Fmt (smg_cmd, "RF %fMHZ", rf);
        break;
    case 3:
        dy = Fmt (smg_cmd, "RF %fGHZ", rf);
        break;
    default:
        smg_err =  -2;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_rf_level (dev, rflvl, rflvlun, rfb)
int dev;
double rflvl;
int rflvlun;
int rfb;
{
    int dy;
    
    switch (rfb)  {
    case 0:
        dy = Fmt (smg_cmd, "LEV:OFF");
        break;
    case 1:
        dy = Fmt (smg_cmd, "LEV %f", rflvl);
        break;
    case 2:
        dy = Fmt (smg_cmd, "LEV:EMF %f", rflvl);
        break;
    default:
        smg_err =  -4;
        return;
        break;
    }
    if (rfb != 0)  
        switch (rflvlun)  {
        case 0:
            if (rfb == 1)  
                dy = Fmt (smg_cmd, "%sDBM", smg_cmd);
            else  
                dy = Fmt (smg_cmd, "LEV %fDBM", rflvl);
            break;
        case 1:
            dy = Fmt (smg_cmd, "%sDBUV", smg_cmd);
            break;
        case 2:
            dy = Fmt (smg_cmd, "%sMV", smg_cmd);
            break;
        case 3:
            dy = Fmt (smg_cmd, "%sUV", smg_cmd);
            break;
        default:
            smg_err =  -3;
            return;
            break;
        }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_af (dev, af, afunit)
int dev;
double af;
int afunit;
{
    int dy;
    
    switch (afunit)  {
    case 0:
        dy = Fmt (smg_cmd, "AF %fHZ", af);
        break;
    case 1:
        dy = Fmt (smg_cmd, "AF %fKHZ", af);
        break;
    default:
        smg_err =  -5;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_af_level (dev, aflev, afb)
int dev;
int aflev;
int afb;
{
    int dy;
    
    switch (afb)  {
    case 0:
        dy = Fmt (smg_cmd, "AF:OFF;SP6");
        break;
    case 1:
        dy = Fmt (smg_cmd, "LEV:AF %iMV;AF:ON", aflev);
        break;
    default:
        smg_err =  -6;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_freq_level (dev, rf, rfun, rflev, rflun, rfb, af, afun, aflev, afb)
int dev;
double rf;
int rfun;
double rflev;
int rflun;
int rfb;
double af;
int afun;
int aflev;
int afb;
{
    int dy;
    
    smg_set_rf (dev, rf, rfun);
    if (smg_err != 0)  
        return;
    smg_op_complete (dev, &dy);
    if (smg_err != 0)  
        return;
    smg_set_af (dev, af, afun);
    if (smg_err != 0)  
        return;
    smg_op_complete (dev, &dy);
    if (smg_err != 0)  
        return;
    smg_set_af_level (dev, aflev, afb);
    if (smg_err != 0)  
        return;
    smg_op_complete (dev, &dy);
    if (smg_err != 0)  
        return;
    smg_set_rf_level (dev, rflev, rflun, rfb);
    if (smg_err != 0)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_freq_level_offset (dev, loffs, roffs, rfunit)
int dev;
double loffs;
double roffs;
int rfunit;
{
    int dy;
    
    dy = Fmt (smg_cmd, "LEV:OFFS %fDB", loffs);
    dy = Fmt (smg_cmd, "%s;RF:OFFS %f", smg_cmd, roffs);
    switch (rfunit)  {
    case 0:
        dy = Fmt (smg_cmd, "%s<%sHZ", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s<%sKHZ", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s<%sMHZ", smg_cmd);
        break;
    default:
        smg_err =  -7;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_modulation (dev, fp, ap, phm, fm, am)
int dev;
int fp;
int ap;
double phm;
double fm;
double am;
{
    int dy;
    
    if (fp < 8)  
        dy = Fmt (smg_cmd, "FM %fKHZ", fm);
    else  
        dy = Fmt (smg_cmd, "PHM %fRAD", phm);
    switch (fp)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;FM:OFF;PHM OFF", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;FM:INT", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;FM:EXT:AC", smg_cmd);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;FM:EXT:DC", smg_cmd);
        break;
    case 4:
        dy = Fmt (smg_cmd, "%s;FM:DUAL:AC", smg_cmd);
        break;
    case 5:
        dy = Fmt (smg_cmd, "%s;FM:DUAL:DC", smg_cmd);
        break;
    case 6:
        dy = Fmt (smg_cmd, "%s;FM:FSK:AC", smg_cmd);
        break;
    case 7:
        dy = Fmt (smg_cmd, "%s;FM:FSK:DC", smg_cmd);
        break;
    case 8:
        dy = Fmt (smg_cmd, "%s;PHM:INT", smg_cmd);
        break;
    case 9:
        dy = Fmt (smg_cmd, "%s;PHM:EXT", smg_cmd);
        break;
    case 10:
        dy = Fmt (smg_cmd, "%s;PHM:DUAL", smg_cmd);
        break;
    default:
        smg_err =  -8;
        return;
        break;
    }
    if (ap != 0 && ap != 6)  
        dy = Fmt (smg_cmd, "%s;AM %fPCT", smg_cmd, am);
    switch (ap)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;AM:OFF", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;AM:INT", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;AM:EXT:AC", smg_cmd);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;AM:EXT:DC", smg_cmd);
        break;
    case 4:
        dy = Fmt (smg_cmd, "%s;AM:DUAL:AC", smg_cmd);
        break;
    case 5:
        dy = Fmt (smg_cmd, "%s;AM:DUAL:DC", smg_cmd);
        break;
    case 6:
        dy = Fmt (smg_cmd, "%s;AM:PULSE", smg_cmd);
        break;
    default:
        smg_err =  -9;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_special_setting (dev, rfb, lcb, nonintb)
int dev;
int rfb;
int lcb;
int nonintb;
{
    int dy;
    
    switch (rfb)  {
    case 0:
        dy = Fmt (smg_cmd, "REF:EXT");
        break;
    case 1:
        dy = Fmt (smg_cmd, "REF:INT");
        break;
    default:
        smg_err =  -10;
        return;
        break;
    }
    switch (lcb)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;ALC:FIX", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;ALC:NORMAL", smg_cmd);
        break;
    default:
        smg_err =  -11;
        return;
        break;
    }
    switch (nonintb)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;ATTEN:NORMAL", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;ATTEN:FIX", smg_cmd);
        break;
    default:
        smg_err =  -12;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_rf_sweep (dev, md, tim, endf, stsiz, startf, stun, endfun, startfun)
int dev;
int md;
double tim;
double endf;
double stsiz;
double startf;
int stun;
int endfun;
int startfun;
{
    int dy;
    
    switch (stun)  {
    case 0:
        dy = Fmt (smg_cmd, "SWP:MODE:RF:LIN;RF:STEP %fHZ", stsiz);
        break;
    case 1:
        dy = Fmt (smg_cmd, "SWP:MODE:RF:LIN;RF:STEP %fKHZ", stsiz);
        break;
    case 2:
        dy = Fmt (smg_cmd, "SWP:MODE:RF:LIN;RF:STEP %fMHZ", stsiz);
        break;
    case 3:
        dy = Fmt (smg_cmd, "SWP:MODE:RF:LIN;RF:STEP %fGHZ", stsiz);
        break;
    case 4:
        dy = Fmt (smg_cmd, "SWP:MODE:RF:LOG;RF:LOG_STEP %fPCT", stsiz);
        break;
    default:
        smg_err =  -13;
        return;
        break;
    }
    dy = Fmt (smg_cmd, "%s;TIME:RF_SWP %fMS", smg_cmd, tim);
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    smg_op_complete (dev, &dy);
    if (smg_err != 0)  
        return;
    switch (endfun)  {
    case 0:
        dy = Fmt (smg_cmd, "RF:STOP %fHZ", endf);
        break;
    case 1:
        dy = Fmt (smg_cmd, "RF:STOP %fKHZ", endf);
        break;
    case 2:
        dy = Fmt (smg_cmd, "RF:STOP %fMHZ", endf);
        break;
    case 3:
        dy = Fmt (smg_cmd, "RF:STOP %fGHZ", endf);
        break;
    default:
        smg_err =  -14;
        return;
        break;
    }
    switch (startfun)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;RF:START %fHZ", smg_cmd, startf);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;RF:START %fKHZ", smg_cmd, startf);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;RF:START %fMHZ", smg_cmd, startf);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;RF:START %fGHZ", smg_cmd, startf);
        break;
    default:
        smg_err =  -15;
        return;
        break;
    }
    switch (md)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;SWP:AUTO", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;SWP:SINGLE", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;SWP:MANUAL", smg_cmd);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;SWP:RESET", smg_cmd);
        break;
    case 4:
        dy = Fmt (smg_cmd, "%s;SWP:OFF", smg_cmd);
        break;
    default:
        smg_err =  -16;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_af_sweep (dev, md, tim, endf, stsiz, startf, stun, endfun, startfun)
int dev;
int md;
double tim;
double endf;
double stsiz;
double startf;
int stun;
int endfun;
int startfun;
{
    int dy;
    
    if (md != 4)  {
        switch (stun)  {
        case 0:
            dy = Fmt (smg_cmd, "SWP:MODE:AF:LIN;AF:STEP %fHZ", stsiz);
            break;
        case 1:
            dy = Fmt (smg_cmd, "SWP:MODE:AF:LIN;AF:STEP %fKHZ", stsiz);
            break;
        case 2:
            dy = Fmt (smg_cmd, "SWP:MODE:AF:LOG;AF:LOG_STEP %fPCT", stsiz);
            break;
        default:
            smg_err =  -17;
            return;
            break;
        }
        dy = Fmt (smg_cmd, "%s;TIME:AF_SWP %fMS", smg_cmd, tim);
        if (smg_write_data (dev, smg_cmd) != 0)  
            return;
        smg_op_complete (dev, &dy);
        if (smg_err != 0)  
            return;
        switch (endfun)  {
        case 0:
            dy = Fmt (smg_cmd, "AF:STOP %fHZ", endf);
            break;
        case 1:
            dy = Fmt (smg_cmd, "AF:STOP %fKHZ", endf);
            break;
        default:
            smg_err =  -18;
            return;
            break;
        }
        switch (startfun)  {
        case 0:
            dy = Fmt (smg_cmd, "%s;AF:START %fHZ", smg_cmd, startf);
            break;
        case 1:
            dy = Fmt (smg_cmd, "%s;AF:START %fKHZ", smg_cmd, startf);
            break;
        default:
            smg_err =  -19;
            return;
            break;
        }
    }
    switch (md)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;SWP:AUTO", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;SWP:SINGLE", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;SWP:MANUAL", smg_cmd);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;SWP:RESET", smg_cmd);
        break;
    case 4:
        dy = Fmt (smg_cmd, "SWP:OFF;SP10");
        break;
    default:
        smg_err =  -20;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_freq_level_step (dev, rfstep, rfun, rflev, afstep, aun, aflev)
int dev;
double rfstep;
int rfun;
double rflev;
double afstep;
int aun;
int aflev;
{
    int dy;
    
    switch (aun)  {
    case 0:
        dy = Fmt (smg_cmd, "AF:VAR %fHZ", afstep);
        break;
    case 1:
        dy = Fmt (smg_cmd, "AF:VAR %fKHZ", afstep);
        break;
    default:
        smg_err =  -21;
        return;
        break;
    }
    dy = Fmt (smg_cmd, "%s;LEV:AF:VAR %iMV", smg_cmd, aflev);
    switch (rfun)  {
    case 0:
        dy = Fmt (smg_cmd, "%s;RF:VAR %fHZ", smg_cmd, rfstep);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s;RF:VAR %fKHZ", smg_cmd, rfstep);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s;RF:VAR %fMHZ", smg_cmd, rfstep);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s;RF:VAR %fGHZ", smg_cmd, rfstep);
        break;
    default:
        smg_err =  -22;
        return;
        break;
    }
    dy = Fmt (smg_cmd, "%s;LEV:VAR %fDB", smg_cmd, rflev);
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_set_modulation_step (dev, am, fm, phm)
int dev;
double am;
double fm;
double phm;
{
    int dy;
    
    dy = Fmt (smg_cmd, "PHM:VAR %fRAD;FM:VAR %fKHZ;AM:VAR %fPCT", phm, fm, am);
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_single_var_step (dev, fun, stp)
int dev;
int fun;
int stp;
{
    int dy;
    
    switch (stp)  {
    case 0:
        dy = Fmt (smg_cmd, "DEC:");
        break;
    case 1:
        dy = Fmt (smg_cmd, "INC:");
        break;
    default:
        smg_err =  -23;
        return;
        break;
    }
    switch (fun)  {
    case 0:
        dy = Fmt (smg_cmd, "%s<%sAF", smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "%s<%sRF", smg_cmd);
        break;
    case 2:
        dy = Fmt (smg_cmd, "%s<%sLEVEL:AF", smg_cmd);
        break;
    case 3:
        dy = Fmt (smg_cmd, "%s<%sLEVEL:RF", smg_cmd);
        break;
    case 4:
        dy = Fmt (smg_cmd, "%s<%sAM", smg_cmd);
        break;
    case 5:
        dy = Fmt (smg_cmd, "%s<%sFM", smg_cmd);
        break;
    case 6:
        dy = Fmt (smg_cmd, "%s<%sPHM", smg_cmd);
        break;
    default:
        smg_err =  -24;
        return;
        break;
    }
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_diagnostics (dev, tpoint, test, testvolt)
int dev;
int tpoint;
int test;
double *testvolt;
{
    int dy;
    
    switch (test)  {
    case 0:
        dy = Fmt (smg_cmd, "TEST:OFF");
        dy = smg_write_data (dev, smg_cmd);
        break;
    case 1:
        dy = Fmt (smg_cmd, "TEST:POINT %i;TEST:VOLT?", tpoint);
        if (smg_write_data (dev, smg_cmd) != 0)  
            return;
        if (smg_read_data (dev, smg_cmd) != 0)  
            return;
        dy = Scan (smg_cmd, "%s>%f", testvolt);
        break;
    default:
        smg_err =  -25;
        return;
        break;
    }
    if (!smg_do_opc)  
        return;
    smg_op_complete (dev, &dy);
}

/* * */
void smg_close (dev)
int dev;
{
    int i;
    
    i = smg_get_handle (dev);
    if (i <= 0)  
        return;
    if (ibloc (i) <= 0)  {
        smg_err = 234;
        return;
    }
    if (CloseDev (i) < 0)  
        smg_err = 221;
    else  
        smg_err = 0;
    smg_bd[dev] = 0;
}

/* * */
void smg_driver_version (p0)
double *p0;
{
    
    smg_version = SMG_VER;
    *p0 = smg_version;
}

/* * */
void smg_op_complete (dev, compl)
int dev;
int *compl;
{
    int dy;
    int esr;
    
    *compl = 0;
    while (!*compl)  {
        dy = Fmt (smg_cmd, "*HDR 0; *OPC?");
        if (smg_write_data (dev, smg_cmd) != 0)  
            return;
        if (smg_read_data (dev, smg_cmd) != 0)  
            return;
        dy = Scan (smg_cmd, "%s>%i", compl);
        if (SMG_MONITOR != 0)  
            *compl = 1;
    }
    dy = Fmt (smg_cmd, "*ESR?");
    if (smg_write_data (dev, smg_cmd) != 0)  
        return;
    if (smg_read_data (dev, smg_cmd) != 0)  
        return;
    dy = Scan (smg_cmd, "%s>%i", &esr);
    if ((esr & 16) != 0)  
        smg_err = 300;
}

void smg_set_opc (onoff)
int onoff;
{
    
    if (onoff != 0)  
        smg_do_opc = 1;
    else  
        smg_do_opc = 0;
}

/* * */
int smg_init (dev, addr)
int dev;
int addr;
{
    int dy;
    
    smg_do_opc = 1;
    if (smg_get_handle (dev) > 0)  
        smg_close (dev);
    if (smg_get_handle (dev) < 0)  
        return  -1;
    if (addr < 0 || addr > 30)  {
        smg_err =  -1;
        return  -1;
    }
    if (SMG_MONITOR != 0)  {
        smg_err = 0;
        smg_bd[dev] = dev + 1;
        return 0;
    }
    smg_bd[dev] = OpenDev ("", "smg_");
    if (smg_bd[dev] <= 0)  {
        smg_err = 220;
        smg_bd[dev] = 0;
        return  -1;
    }
    if (ibpad (smg_bd[dev], addr) < 0)  {
        smg_err = 233;
        return  -1;
    }
    if (ibclr (smg_bd[dev]) <= 0)  {
        smg_err = 236;
        return  -1;
    }
    dy = Fmt (smg_cmd, "*RST; *HDR 0");
    if (smg_write_data (dev, smg_cmd) != 0)  
        return  -1;
    smg_err = 0;
    return 0;
}

/* * */
int smg_read_data (dev, cmd)
int dev;
char *cmd;
{
    int dvh;
    
    dvh = smg_get_handle (dev);
    if (dvh <= 0)  
        return smg_err;
    if (SMG_MONITOR != 0)  {
        smg_err = 0;
        dvh = Fmt (cmd, "");
        return 0;
    }
    if (ibrd (dvh, cmd, 255L) <= 0)  
        smg_err = 231;
    else  
        smg_err = 0;
    return smg_err;
}

/* * */
int smg_write_data (dev, cmd)
int dev;
char *cmd;
{
    char loc_cmd[256];
    int dvh;
    int i;
    
    dvh = smg_get_handle (dev);
    if (dvh <= 0)  
        return smg_err;
    if (SMG_MONITOR != 0 || SMG_SHOW_WRITE_DATA != 0)  
        i = FmtOut ("%s\r\n", cmd);
    if (SMG_MONITOR != 0)  
        smg_err = 0;
    else  {
        i = Fmt (loc_cmd, "%s", cmd);
        if (ibwrt (dvh, loc_cmd, (long)NumFmtdBytes ()) <= 0)  
            smg_err = 230;
        else  
            smg_err = 0;
    }
    return smg_err;
}

/* * */
int smg_get_handle (devnr)
int devnr;
{
    
    if (devnr < 0 || devnr > 3)  {
        smg_err = 217;
        return  -1;
    }
    if (smg_bd[devnr] <= 0)  {
        smg_err = 218;
        return 0;
    }
    smg_err = 0;
    return smg_bd[devnr];
}

